/***********************************************
 *
 * OG Script Dumper v2.6 by learn_more
 * File: out\a184\script\cam_dump.as
 * Generated: 03-Jul-2012 19:50:45
 * Overgrowth.exe base: 0x400000
 *
 ***********************************************/

#include "shared_dump.as"


/***********************************************
 * Files that can access these (and included) functions/objects/properties:
 */

	// cam.as


/***********************************************
 * Global Functions:
 */

vec3 __cdecl LineLineIntersect(vec3,vec3,vec3,vec3)			// 'Overgrowth.exe' + 0x3b9280 (0x7b9280)


/***********************************************
 * Objects:
 */

class CollisionPoint
{		// size: 0x1c, flags:  asOBJ_VALUE asOBJ_POD asOBJ_APP_CLASS
	vec3 position;		// byteOffset: 0x0
	vec3 normal;		// byteOffset: 0xc
	int id;		// byteOffset: 0x18
};

class SphereCollision
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	float radius;		// byteOffset: 0x0
	vec3 position;		// byteOffset: 0x4
	vec3 adjusted_position;		// byteOffset: 0x10
//-----
	int NumContacts();		// 'Overgrowth.exe' + 0xc25c0 (0x4c25c0)
	CollisionPoint GetContact(int);		// 'Overgrowth.exe' + 0xc25f0 (0x4c25f0)
};

class ASCollisions
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	vec3 GetSlidingCapsuleCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3b9700 (0x7b9700)
	void GetSlidingSphereCollision(vec3,float);		// 'Overgrowth.exe' + 0x3b9e40 (0x7b9e40)
	void GetScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3b9bd0 (0x7b9bd0)
	void GetScaledSpherePlantCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3b9ac0 (0x7b9ac0)
	void GetSlidingScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3b9ea0 (0x7b9ea0)
	void GetCylinderCollision(vec3,float,float);		// 'Overgrowth.exe' + 0x3b9990 (0x7b9990)
	void GetSweptSphereCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3b96b0 (0x7b96b0)
	void GetSweptSphereCollisionCharacters(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3b9e70 (0x7b9e70)
	void GetSweptCylinderCollision(vec3,vec3,float,float);		// 'Overgrowth.exe' + 0x3b9730 (0x7b9730)
	void GetSweptBoxCollision(vec3,vec3,vec3);		// 'Overgrowth.exe' + 0x3b9860 (0x7b9860)
	void CheckRayCollisionCharacters(vec3,vec3);		// 'Overgrowth.exe' + 0x3b92d0 (0x7b92d0)
	vec3 GetRayCollision(vec3,vec3);		// 'Overgrowth.exe' + 0x3b8da0 (0x7b8da0)
};

class GUI
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	uint32 AddGUI(string, string, int, int, uint8);		// 'Overgrowth.exe' + 0x24f8a0 (0x64f8a0)
	void RemoveGUI(uint32);		// 'Overgrowth.exe' + 0x24e720 (0x64e720)
	void Execute(uint32, string);		// 'Overgrowth.exe' + 0x24e780 (0x64e780)
	void MoveTo(uint32, int, int);		// 'Overgrowth.exe' + 0x24f6b0 (0x64f6b0)
	string GetCallback(uint32);		// 'Overgrowth.exe' + 0x24f720 (0x64f720)
	void Update();		// 'Overgrowth.exe' + 0x253810 (0x653810)
};

class CameraObject
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	bool controlled;		// byteOffset: 0x84
	vec3 position;		// byteOffset: 0x88
	bool frozen;		// byteOffset: 0xd4
	vec3 velocity;		// byteOffset: 0xd8
	bool ignore_mouse_input;		// byteOffset: 0xe8
//-----
	void LoadParallaxScene(string, string);		// 'Overgrowth.exe' + 0x2ae350 (0x6ae350)
	void UnloadParallaxScene();		// 'Overgrowth.exe' + 0x2ae300 (0x6ae300)
};

class CameraAnimationReader
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	void AttachTo(string);		// 'Overgrowth.exe' + 0x37fdc0 (0x77fdc0)
	vec3 GetPosition();		// 'Overgrowth.exe' + 0x37fc20 (0x77fc20)
	vec4 GetRotationVec4();		// 'Overgrowth.exe' + 0x37fbb0 (0x77fbb0)
	float GetLens();		// 'Overgrowth.exe' + 0x37fc00 (0x77fc00)
	void Update();		// 'Overgrowth.exe' + 0x380240 (0x780240)
	bool valid();		// 'Overgrowth.exe' + 0x37e180 (0x77e180)
};



/***********************************************
 * Global Properties:
 */

ASCollisions col;		// 0x1920b9f0
SphereCollision sphere_col;		// 0x1920b9f4
GUI gui;		// 0x1bdad560
uint8 _GG_IGNORES_MOUSE;		// 'Overgrowth.exe' + 0x439fd0 (0x839fd0)
CameraObject co;		// 0x224216b0
CameraAnimationReader camera_animation_reader;		// 0x2242179c
